var sOutput = validateFile("pelencorisorse.xml");

WScript.Echo(sOutput);

function OttieniDimensioneFile(strFile)
{
	var fso = new ActiveXObject('Scripting.FileSystemObject');
	var file = fso.GetFile(strFile);
	var dimensioneFile = file.Size;
	return dimensioneFile;
}

function validateFile(strFile)
{
    // Create an XML DOMDocument object.
     try {
       var x = new ActiveXObject("MSXML2.DOMDocument.6.0");
    }
    catch(err) {

       var x = new ActiveXObject("MSXML2.DOMDocument.4.0");
    }
	
    //Load and validate the specified file into the DOM.
    x.async = false;
    x.validateOnParse = true;
    x.resolveExternals = true;
    x.load(strFile);

	var vFlagVerifica = 0;
	var vImporto;
	vImporto="";
	var verif=new Array(0,0);
	var duplicati=new Array(0,0);
	var z=1;

	var vFlagParse = false;
	// Return validation results in message to the user.
    if (x.parseError.errorCode != 0)
    {
        vFlagParse = false;
    }
    else{
	
       vFlagParse = true;
   }
	

	
	if(vFlagParse != true){
		
		return("Errore di validazione file: " + strFile + 
			"\n=====================" +
			"\nMotivo: " + x.parseError.reason + 
			"\nSorgente: " + x.parseError.srcText + 
			"\nLinea: " + x.parseError.line + "\n");
	} else {
	  //se la validazione  andato ok eseguo il codice del Tributo provinciale
	  /*****************/
	  var vFlagVerificaT = 0;
		var vImportoT;
		vImportoT="";
		var verifT=new Array(0,0);
	  var duplicatiT=new Array(0,0);
	  var zT=1;

		var objT = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa5/Riga");
		if(objT.hasChildNodes==true){
			//WScript.Echo("SI " + objT.childNodes.length);
			for(i=0;i<objT.childNodes.length;i++){
				if(objT.childNodes.item(i).tagName!="NRif"){
					vImportoT = objT.childNodes.item(i).text.replace(",",".");
						if(parseFloat(vImportoT)>0) {
						  
          	    if (zT==1 || zT==4 ||zT==7 || zT==10 || zT==13 ){
          		  verifT[0]=1;
          	  }
          	  else if (zT==2 || zT==5 ||zT==8 || zT==11 || zT==14 ){
              	  verifT[1]=1;
                }
					}
					zT++;
				}
			}
			  if(verifT[0]>0)
          	duplicatiT[0]++;
        if(verifT[1]>0)
          	duplicatiT[1]++;
		}
		vImportoT="";
		zT=1;
		verifT[0]=0;
		verifT[1]=0;
		
		objT = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria3/Risorsa2/Riga");
		if(objT.hasChildNodes==true){
			//WScript.Echo("SI " + objT.childNodes.length);
			for(i=0;i<objT.childNodes.length;i++){
				if(objT.childNodes.item(i).tagName!="NRif"){
					vImportoT = objT.childNodes.item(i).text.replace(",",".");
						if(parseFloat(vImportoT)>0) {
						  
          	  if (zT==1 || zT==4 ||zT==7 || zT==10 || zT==13 ){
          		  verifT[0]=1;
          	  }
          	  else if (zT==2 || zT==5 ||zT==8 || zT==11 || zT==14 ){
              	  verifT[1]=1;
                }
					}
					zT++;
				}
			}
			  if(verifT[0]>0)
          	duplicatiT[0]++;
        if(verifT[1]>0)
          	duplicatiT[1]++;
		}
		
		
		if (duplicatiT[0]>1 || duplicatiT[1]>1){
			if (error != null && error != ""){
				error = error + 
				"\n=====================" +
				"\nMotivo: Inserire una sola voce relativa al Tributo provinciale per l'esercizio delle funzioni di tutela, protezione e igiene dell'ambiente";
			} else {
				error = "Errore di validazione file: " + strFile + 
				"\n=====================" +
				"\nMotivo: Inserire una sola voce relativa al Tributo provinciale per l'esercizio delle funzioni di tutela, protezione e igiene dell'ambiente";
			}
			return error;
		}

	/*****************************/	
		
		// controllo la data di delibera
		var giorno = x.selectSingleNode("//Copertina/DataDelibera/Giorno").text;
		var mese = x.selectSingleNode("//Copertina/DataDelibera/Mese").text;
		var anno = x.selectSingleNode("//Copertina/DataDelibera/Anno").text;
		if(!isDataValida(giorno, mese, anno)){
			return("Errore di validazione file: " + strFile +
					"\n==========================" +
					"\nMotivo: La data delibera immessa '"+giorno+"/"+mese+"/"+anno+"' non  valida");
		}
		// fine controllo data di delibera
		
		if(OttieniDimensioneFile(strFile)>3000000){

			return("Errore di validazione file: " + strFile +
				"\n==========================" +
				"\n La dimensione  maggiore di 3 Mb");
		}
		/**************************************************************************************/
		/*** INIZIO MODIFICHE PER CONTROLLO SU CODICE E DESCRIZIONE DELLE PROVINCIE ***/
		/**************************************************************************************/
		var codice = "1010001";
		var descrizione = "Imposta sulle assicurazioni RC auto";
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa1/Codice1");
		var error = controllaCodice(strFile,obj,codice,descrizione);
		if(error != "") return error;
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa1/Descrizione1");
		var error = controllaDescrizione(strFile,obj,codice,descrizione);
		if(error != "") return error;
		
		codice = "1010002";
		descrizione = "Imposta provinciale sulle formalita' di trascrizione";
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa2/Codice2");
		var error = controllaCodice(strFile,obj,codice,descrizione);
		if(error != "") return error;
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa2/Descrizione2");
		var error = controllaDescrizione(strFile,obj,codice,descrizione);
		if(error != "") return error;
		
		var codice = "1010005";
		var descrizione = "Tributo provinciale per l'esercizio delle funzioni di tutela, protezione e igiene dell'ambiente (2)";
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa5/Codice7");
		var error = controllaCodice(strFile,obj,codice,descrizione);
		if(error != "") return error;
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria1/Risorsa5/Descrizione7");
		var error = controllaDescrizione(strFile,obj,codice,descrizione);
		if(error != "") return error;
		
        /***************************/
		codice = "1030002";
		descrizione = "Tributo provinciale per l'esercizio delle funzioni di tutela, protezione e igiene dell'ambiente (2)";
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria3/Risorsa2/Codice8");
		var error = controllaCodice(strFile,obj,codice,descrizione);
		if(error != "") return error;
		obj = x.selectSingleNode("//TotaleGenerale/TitoloI/Categoria3/Risorsa2/Descrizione8");
		var error = controllaDescrizione(strFile,obj,codice,descrizione);
		if(error != "") return error;
		
		/***************************/
	
		/***************************/
		
		codice = "3010001";
		descrizione = "Entrate per violazione del codice della strada";
		obj = x.selectSingleNode("//TotaleGenerale/TitoloIII/Categoria1/Risorsa1/Codice");
		var error = controllaCodice(strFile,obj,codice,descrizione);
		if(error != "") return error;
		obj = x.selectSingleNode("//TotaleGenerale/TitoloIII/Categoria1/Risorsa1/Descrizione");
		var error = controllaDescrizione(strFile,obj,codice,descrizione);
		if(error != "") return error;
		/****************************/
		/***********************************************************************************/
		/*** FINE MODIFICHE PER CONTROLLO SU CODICE E DESCRIZIONE DELLE PROVINCIE ***/
		/***********************************************************************************/		

		return("Validazione effettuata con successo: " +  strFile +
				"\n===================================\n" 
				);
	} 
}

function controllaDescrizione(strFile,obj,codice,descrizione){
	var error = "";
	if(obj!=null){
		var tmp = obj.text;
		if(tmp != descrizione)
			error = "Errore di validazione file: " + strFile + 
				"\n=====================" +
				"\nMotivo: La Descrizione del codice " + codice + " " +
				"\n \"" + descrizione + "\"";			
	}
	return error;
}
	
function controllaCodice(strFile,obj,codice,descrizione){
	var error = "";
	if(obj!=null){
		var tmp = obj.text;
		if(tmp != codice){
			error = "Errore di validazione file: " + strFile + 
				"\n=====================" +
				"\nMotivo: Il Codice di \"" + descrizione + "\"  " + codice;
		}
	}	
	return error;
}

// controlla se la data inserita corrisponde a una data valida
function isDataValida(giorno, mese, anno)
{
	var mydate = new Date(anno, mese-1, giorno);
	var today = new Date();
	
	if(mydate.getDate() != giorno || mydate.getMonth()+1 != mese || mydate.getFullYear() != anno){
		return false;
	}

	 // day value between 1 and 31 
	 if(mydate.getDate() < 1 || mydate.getDate() > 31) 
	 { return false; } 
	 // month value between 1 and 12 
	 if(mydate.getMonth() < 0 || mydate.getMonth() > 11) 
	 { return false; } 
	 // year value between 2000 and current year 
	if(mydate.getFullYear() <= 2000 || mydate.getFullYear() > today.getYear())
	{ return false;} 
	
	return true;
}

